Index: tree-vect-analyze.c
===================================================================
RCS file: /cvs/gcc/gcc/gcc/tree-vect-analyze.c,v
retrieving revision 2.31
diff -Idpatel.pbxuser -c -3 -p -r2.31 tree-vect-analyze.c
*** tree-vect-analyze.c	26 Jun 2005 21:21:33 -0000	2.31
--- tree-vect-analyze.c	6 Jul 2005 02:12:41 -0000
*************** vect_analyze_data_refs_alignment (loop_v
*** 1403,1419 ****
        supportable_dr_alignment = vect_supportable_dr_alignment (dr);
        if (!supportable_dr_alignment)
  	{
! 	  if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 				    LOOP_LOC (loop_vinfo)))
  	    fprintf (vect_dump, "not vectorized: unsupported unaligned store.");
  	  return false;
  	}
        if (supportable_dr_alignment != dr_aligned 
! 	  && (vect_print_dump_info (REPORT_ALIGNMENT, LOOP_LOC (loop_vinfo))))
  	fprintf (vect_dump, "Vectorizing an unaligned access.");
      }
    if (LOOP_VINFO_UNALIGNED_DR (loop_vinfo)
!       && vect_print_dump_info (REPORT_ALIGNMENT, LOOP_LOC (loop_vinfo)))
      fprintf (vect_dump, "Alignment of access forced using peeling.");
  
    return true;
--- 1384,1399 ----
        supportable_dr_alignment = vect_supportable_dr_alignment (dr);
        if (!supportable_dr_alignment)
  	{
! 	  if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	    fprintf (vect_dump, "not vectorized: unsupported unaligned store.");
  	  return false;
  	}
        if (supportable_dr_alignment != dr_aligned 
! 	  && (vect_print_dump_info (REPORT_ALIGNMENT)))
  	fprintf (vect_dump, "Vectorizing an unaligned access.");
      }
    if (LOOP_VINFO_UNALIGNED_DR (loop_vinfo)
!       && vect_print_dump_info (REPORT_ALIGNMENT))
      fprintf (vect_dump, "Alignment of access forced using peeling.");
  
    return true;
*************** vect_analyze_data_ref_access (struct dat
*** 1435,1441 ****
  
    if (!step || tree_int_cst_compare (step, TYPE_SIZE_UNIT (scalar_type)))
      {
!       if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	fprintf (vect_dump, "not consecutive access");
        return false;
      }
--- 1415,1421 ----
  
    if (!step || tree_int_cst_compare (step, TYPE_SIZE_UNIT (scalar_type)))
      {
!       if (vect_print_dump_info (REPORT_DETAILS))
  	fprintf (vect_dump, "not consecutive access");
        return false;
      }
*************** vect_analyze_data_ref_accesses (loop_vec
*** 1459,1465 ****
    varray_type loop_write_datarefs = LOOP_VINFO_DATAREF_WRITES (loop_vinfo);
    varray_type loop_read_datarefs = LOOP_VINFO_DATAREF_READS (loop_vinfo);
  
!   if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
      fprintf (vect_dump, "=== vect_analyze_data_ref_accesses ===");
  
    for (i = 0; i < VARRAY_ACTIVE_SIZE (loop_write_datarefs); i++)
--- 1439,1445 ----
    varray_type loop_write_datarefs = LOOP_VINFO_DATAREF_WRITES (loop_vinfo);
    varray_type loop_read_datarefs = LOOP_VINFO_DATAREF_READS (loop_vinfo);
  
!   if (vect_print_dump_info (REPORT_DETAILS))
      fprintf (vect_dump, "=== vect_analyze_data_ref_accesses ===");
  
    for (i = 0; i < VARRAY_ACTIVE_SIZE (loop_write_datarefs); i++)
*************** vect_analyze_data_ref_accesses (loop_vec
*** 1468,1475 ****
        bool ok = vect_analyze_data_ref_access (dr);
        if (!ok)
  	{
! 	  if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
!                                       LOOP_LOC (loop_vinfo)))
  	    fprintf (vect_dump, "not vectorized: complicated access pattern.");
  	  return false;
  	}
--- 1448,1454 ----
        bool ok = vect_analyze_data_ref_access (dr);
        if (!ok)
  	{
! 	  if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	    fprintf (vect_dump, "not vectorized: complicated access pattern.");
  	  return false;
  	}
*************** vect_analyze_data_ref_accesses (loop_vec
*** 1481,1488 ****
        bool ok = vect_analyze_data_ref_access (dr);
        if (!ok)
  	{
! 	  if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 				    LOOP_LOC (loop_vinfo)))
  	    fprintf (vect_dump, "not vectorized: complicated access pattern.");
  	  return false;
  	}
--- 1460,1466 ----
        bool ok = vect_analyze_data_ref_access (dr);
        if (!ok)
  	{
! 	  if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	    fprintf (vect_dump, "not vectorized: complicated access pattern.");
  	  return false;
  	}
*************** vect_analyze_pointer_ref_access (tree me
*** 1521,1528 ****
  
    if (!vect_is_simple_iv_evolution (loopnum, access_fn, &init, &step))
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS, 
! 				LOOP_LOC (loop_vinfo))) 
  	fprintf (vect_dump, "not vectorized: pointer access is not simple.");	
        return NULL;
      }
--- 1499,1505 ----
  
    if (!vect_is_simple_iv_evolution (loopnum, access_fn, &init, &step))
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	fprintf (vect_dump, "not vectorized: pointer access is not simple.");	
        return NULL;
      }
*************** vect_analyze_pointer_ref_access (tree me
*** 1531,1538 ****
  
    if (!expr_invariant_in_loop_p (loop, init))
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 				LOOP_LOC (loop_vinfo))) 
  	fprintf (vect_dump, 
  		 "not vectorized: initial condition is not loop invariant.");	
        return NULL;
--- 1508,1514 ----
  
    if (!expr_invariant_in_loop_p (loop, init))
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	fprintf (vect_dump, 
  		 "not vectorized: initial condition is not loop invariant.");	
        return NULL;
*************** vect_analyze_pointer_ref_access (tree me
*** 1540,1547 ****
  
    if (TREE_CODE (step) != INTEGER_CST)
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 				LOOP_LOC (loop_vinfo))) 
  	fprintf (vect_dump, 
  		"not vectorized: non constant step for pointer access.");	
        return NULL;
--- 1516,1522 ----
  
    if (TREE_CODE (step) != INTEGER_CST)
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	fprintf (vect_dump, 
  		"not vectorized: non constant step for pointer access.");	
        return NULL;
*************** vect_analyze_pointer_ref_access (tree me
*** 1550,1565 ****
    reftype = TREE_TYPE (TREE_OPERAND (memref, 0));
    if (!POINTER_TYPE_P (reftype)) 
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 				LOOP_LOC (loop_vinfo)))
  	fprintf (vect_dump, "not vectorized: unexpected pointer access form.");	
        return NULL;
      }
  
    if (!POINTER_TYPE_P (TREE_TYPE (init))) 
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 				LOOP_LOC (loop_vinfo))) 
  	fprintf (vect_dump, "not vectorized: unexpected pointer access form.");
        return NULL;
      }
--- 1525,1538 ----
    reftype = TREE_TYPE (TREE_OPERAND (memref, 0));
    if (!POINTER_TYPE_P (reftype)) 
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	fprintf (vect_dump, "not vectorized: unexpected pointer access form.");	
        return NULL;
      }
  
    if (!POINTER_TYPE_P (TREE_TYPE (init))) 
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	fprintf (vect_dump, "not vectorized: unexpected pointer access form.");
        return NULL;
      }
*************** vect_analyze_pointer_ref_access (tree me
*** 1568,1576 ****
    innertype = TREE_TYPE (reftype);
    if (!COMPLETE_TYPE_P (innertype))
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
!                               LOOP_LOC (loop_vinfo)))
!       fprintf (vect_dump, "not vectorized: pointer to incomplete type.");
        return NULL;
      }
     
--- 1541,1548 ----
    innertype = TREE_TYPE (reftype);
    if (!COMPLETE_TYPE_P (innertype))
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
! 	fprintf (vect_dump, "not vectorized: pointer to incomplete type.");
        return NULL;
      }
     
*************** vect_analyze_pointer_ref_access (tree me
*** 1578,1592 ****
    if (!integer_zerop (size_binop (TRUNC_MOD_EXPR, *ptr_step, 
   		        fold_convert (ssizetype, TYPE_SIZE_UNIT (innertype)))))
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 				LOOP_LOC (loop_vinfo))) 
  	fprintf (vect_dump, "not vectorized: non consecutive access.");	
        return NULL;
      }
     
    indx_access_fn = 
  	build_polynomial_chrec (loopnum, integer_zero_node, integer_one_node);
!   if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
      {
        fprintf (vect_dump, "Access function of ptr indx: ");
        print_generic_expr (vect_dump, indx_access_fn, TDF_SLIM);
--- 1550,1563 ----
    if (!integer_zerop (size_binop (TRUNC_MOD_EXPR, *ptr_step, 
   		        fold_convert (ssizetype, TYPE_SIZE_UNIT (innertype)))))
      {
!       if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	fprintf (vect_dump, "not vectorized: non consecutive access.");	
        return NULL;
      }
     
    indx_access_fn = 
  	build_polynomial_chrec (loopnum, integer_zero_node, integer_one_node);
!   if (vect_print_dump_info (REPORT_DETAILS))
      {
        fprintf (vect_dump, "Access function of ptr indx: ");
        print_generic_expr (vect_dump, indx_access_fn, TDF_SLIM);
*************** vect_object_analysis (tree memref, tree 
*** 1810,1816 ****
  	  && !vect_analyze_offset_expr (poffset, loop, TYPE_SIZE_UNIT (vectype), 
  				&object_offset, &object_misalign, &object_step))
  	{
! 	  if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	    {
  	      fprintf (vect_dump, "failed to compute offset or step for ");
  	      print_generic_expr (vect_dump, memref, TDF_SLIM);
--- 1781,1787 ----
  	  && !vect_analyze_offset_expr (poffset, loop, TYPE_SIZE_UNIT (vectype), 
  				&object_offset, &object_misalign, &object_step))
  	{
! 	  if (vect_print_dump_info (REPORT_DETAILS))
  	    {
  	      fprintf (vect_dump, "failed to compute offset or step for ");
  	      print_generic_expr (vect_dump, memref, TDF_SLIM);
*************** vect_object_analysis (tree memref, tree 
*** 1824,1830 ****
        /* Check that there is no remainder in bits.  */
        if (pbitpos%BITS_PER_UNIT)
  	{
! 	  if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	    fprintf (vect_dump, "bit offset alignment.");
  	  return NULL_TREE;
  	}
--- 1795,1801 ----
        /* Check that there is no remainder in bits.  */
        if (pbitpos%BITS_PER_UNIT)
  	{
! 	  if (vect_print_dump_info (REPORT_DETAILS))
  	    fprintf (vect_dump, "bit offset alignment.");
  	  return NULL_TREE;
  	}
*************** vect_object_analysis (tree memref, tree 
*** 1852,1858 ****
        /* We expect to get a decl only if we already have a DR.  */
        if (!(*dr))
  	{
! 	  if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	    {
  	      fprintf (vect_dump, "unhandled decl ");
  	      print_generic_expr (vect_dump, memref, TDF_SLIM);
--- 1823,1829 ----
        /* We expect to get a decl only if we already have a DR.  */
        if (!(*dr))
  	{
! 	  if (vect_print_dump_info (REPORT_DETAILS))
  	    {
  	      fprintf (vect_dump, "unhandled decl ");
  	      print_generic_expr (vect_dump, memref, TDF_SLIM);
*************** vect_object_analysis (tree memref, tree 
*** 1889,1900 ****
        access_fn = analyze_scalar_evolution (loop, ptr_ref);
        if (!access_fn)
  	{
! 	  if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 				    LOOP_LOC (loop_vinfo)))
  	    fprintf (vect_dump, "not vectorized: complicated pointer access.");	
  	  return NULL_TREE;
  	}
!       if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	{
  	  fprintf (vect_dump, "Access function of ptr: ");
  	  print_generic_expr (vect_dump, access_fn, TDF_SLIM);
--- 1860,1870 ----
        access_fn = analyze_scalar_evolution (loop, ptr_ref);
        if (!access_fn)
  	{
! 	  if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	    fprintf (vect_dump, "not vectorized: complicated pointer access.");	
  	  return NULL_TREE;
  	}
!       if (vect_print_dump_info (REPORT_DETAILS))
  	{
  	  fprintf (vect_dump, "Access function of ptr: ");
  	  print_generic_expr (vect_dump, access_fn, TDF_SLIM);
*************** vect_object_analysis (tree memref, tree 
*** 1916,1923 ****
  	{
  	  if (!(*dr))
  	    {
! 	      if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 					LOOP_LOC (loop_vinfo))) 
  		fprintf (vect_dump, "not vectorized: ptr is loop invariant.");	
  	      return NULL_TREE;
  	    }
--- 1886,1892 ----
  	{
  	  if (!(*dr))
  	    {
! 	      if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  		fprintf (vect_dump, "not vectorized: ptr is loop invariant.");	
  	      return NULL_TREE;
  	    }
*************** vect_object_analysis (tree memref, tree 
*** 1951,1958 ****
  	  *memtag = TREE_OPERAND (base_address, 0);
  	  break;
  	default:
! 	  if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 				    LOOP_LOC (loop_vinfo)))
  	    {
  	      fprintf (vect_dump, "not vectorized: no memtag ref: "); 
  	      print_generic_expr (vect_dump, memref, TDF_SLIM);
--- 1920,1926 ----
  	  *memtag = TREE_OPERAND (base_address, 0);
  	  break;
  	default:
! 	  if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  	    {
  	      fprintf (vect_dump, "not vectorized: no memtag ref: "); 
  	      print_generic_expr (vect_dump, memref, TDF_SLIM);
*************** vect_object_analysis (tree memref, tree 
*** 1978,1984 ****
    *step = size_binop (PLUS_EXPR, object_step, address_step); 
    *base_aligned = object_base_aligned && address_base_aligned;
  
!   if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
      {
        fprintf (vect_dump, "Results of object analysis for: ");
        print_generic_expr (vect_dump, memref, TDF_SLIM);
--- 1946,1952 ----
    *step = size_binop (PLUS_EXPR, object_step, address_step); 
    *base_aligned = object_base_aligned && address_base_aligned;
  
!   if (vect_print_dump_info (REPORT_DETAILS))
      {
        fprintf (vect_dump, "Results of object analysis for: ");
        print_generic_expr (vect_dump, memref, TDF_SLIM);
*************** vect_analyze_data_refs (loop_vec_info lo
*** 2030,2036 ****
    int j;
    struct data_reference *dr;
  
!   if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
      fprintf (vect_dump, "=== vect_analyze_data_refs ===");
  
    for (j = 0; j < nbbs; j++)
--- 1998,2004 ----
    int j;
    struct data_reference *dr;
  
!   if (vect_print_dump_info (REPORT_DETAILS))
      fprintf (vect_dump, "=== vect_analyze_data_refs ===");
  
    for (j = 0; j < nbbs; j++)
*************** vect_analyze_data_refs (loop_vec_info lo
*** 2061,2067 ****
  
  	  if (!no_vuse && !no_vmaymust)
  	    {
! 	      if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  		{
  		  fprintf (vect_dump, "unexpected vdefs and vuses in stmt: ");
  		  print_generic_expr (vect_dump, stmt, TDF_SLIM);
--- 2029,2035 ----
  
  	  if (!no_vuse && !no_vmaymust)
  	    {
! 	      if (vect_print_dump_info (REPORT_DETAILS))
  		{
  		  fprintf (vect_dump, "unexpected vdefs and vuses in stmt: ");
  		  print_generic_expr (vect_dump, stmt, TDF_SLIM);
*************** vect_analyze_data_refs (loop_vec_info lo
*** 2071,2077 ****
  
  	  if (TREE_CODE (stmt) != MODIFY_EXPR)
  	    {
! 	      if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  		{
  		  fprintf (vect_dump, "unexpected vops in stmt: ");
  		  print_generic_expr (vect_dump, stmt, TDF_SLIM);
--- 2039,2045 ----
  
  	  if (TREE_CODE (stmt) != MODIFY_EXPR)
  	    {
! 	      if (vect_print_dump_info (REPORT_DETAILS))
  		{
  		  fprintf (vect_dump, "unexpected vops in stmt: ");
  		  print_generic_expr (vect_dump, stmt, TDF_SLIM);
*************** vect_analyze_data_refs (loop_vec_info lo
*** 2096,2102 ****
  	  vectype = get_vectype_for_scalar_type (scalar_type);
  	  if (!vectype)
  	    {
! 	      if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  		{
  		  fprintf (vect_dump, "no vectype for stmt: ");
  		  print_generic_expr (vect_dump, stmt, TDF_SLIM);
--- 2064,2070 ----
  	  vectype = get_vectype_for_scalar_type (scalar_type);
  	  if (!vectype)
  	    {
! 	      if (vect_print_dump_info (REPORT_DETAILS))
  		{
  		  fprintf (vect_dump, "no vectype for stmt: ");
  		  print_generic_expr (vect_dump, stmt, TDF_SLIM);
*************** vect_analyze_data_refs (loop_vec_info lo
*** 2115,2122 ****
  				       &subvars);
  	  if (!base)
  	    {
! 	      if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 					LOOP_LOC (loop_vinfo)))
  		{
  		  fprintf (vect_dump, "not vectorized: unhandled data ref: "); 
  		  print_generic_expr (vect_dump, stmt, TDF_SLIM);
--- 2083,2089 ----
  				       &subvars);
  	  if (!base)
  	    {
! 	      if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
  		{
  		  fprintf (vect_dump, "not vectorized: unhandled data ref: "); 
  		  print_generic_expr (vect_dump, stmt, TDF_SLIM);
*************** vect_mark_relevant (VEC(tree,heap) **wor
*** 2155,2161 ****
    bool save_relevant_p = STMT_VINFO_RELEVANT_P (stmt_info);
    bool save_live_p = STMT_VINFO_LIVE_P (stmt_info);
  
!   if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
      fprintf (vect_dump, "mark relevant %d, live %d.",relevant_p, live_p);
  
    STMT_VINFO_LIVE_P (stmt_info) |= live_p;
--- 2122,2128 ----
    bool save_relevant_p = STMT_VINFO_RELEVANT_P (stmt_info);
    bool save_live_p = STMT_VINFO_LIVE_P (stmt_info);
  
!   if (vect_print_dump_info (REPORT_DETAILS))
      fprintf (vect_dump, "mark relevant %d, live %d.",relevant_p, live_p);
  
    STMT_VINFO_LIVE_P (stmt_info) |= live_p;
*************** vect_mark_relevant (VEC(tree,heap) **wor
*** 2169,2175 ****
    if (STMT_VINFO_RELEVANT_P (stmt_info) == save_relevant_p
        && STMT_VINFO_LIVE_P (stmt_info) == save_live_p)
      {
!       if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
          fprintf (vect_dump, "already marked relevant/live.");
        return;
      }
--- 2136,2142 ----
    if (STMT_VINFO_RELEVANT_P (stmt_info) == save_relevant_p
        && STMT_VINFO_LIVE_P (stmt_info) == save_live_p)
      {
!       if (vect_print_dump_info (REPORT_DETAILS))
          fprintf (vect_dump, "already marked relevant/live.");
        return;
      }
*************** vect_stmt_relevant_p (tree stmt, loop_ve
*** 2211,2217 ****
    if (TREE_CODE (stmt) != PHI_NODE)
      if (!ZERO_SSA_OPERANDS (stmt, SSA_OP_VIRTUAL_DEFS))
        {
! 	if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	  fprintf (vect_dump, "vec_stmt_relevant_p: stmt has vdefs.");
  	*relevant_p = true;
        }
--- 2178,2184 ----
    if (TREE_CODE (stmt) != PHI_NODE)
      if (!ZERO_SSA_OPERANDS (stmt, SSA_OP_VIRTUAL_DEFS))
        {
! 	if (vect_print_dump_info (REPORT_DETAILS))
  	  fprintf (vect_dump, "vec_stmt_relevant_p: stmt has vdefs.");
  	*relevant_p = true;
        }
*************** vect_stmt_relevant_p (tree stmt, loop_ve
*** 2224,2230 ****
  	  basic_block bb = bb_for_stmt (USE_STMT (use_p));
  	  if (!flow_bb_inside_loop_p (loop, bb))
  	    {
! 	      if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  		fprintf (vect_dump, "vec_stmt_relevant_p: used out of loop.");
  
  	      /* We expect all such uses to be in the loop exit phis
--- 2191,2197 ----
  	  basic_block bb = bb_for_stmt (USE_STMT (use_p));
  	  if (!flow_bb_inside_loop_p (loop, bb))
  	    {
! 	      if (vect_print_dump_info (REPORT_DETAILS))
  		fprintf (vect_dump, "vec_stmt_relevant_p: used out of loop.");
  
  	      /* We expect all such uses to be in the loop exit phis
*************** vect_mark_stmts_to_be_vectorized (loop_v
*** 2276,2282 ****
    tree def, def_stmt;
    enum vect_def_type dt;
  
!   if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
      fprintf (vect_dump, "=== vect_mark_stmts_to_be_vectorized ===");
  
    worklist = VEC_alloc (tree, heap, 64);
--- 2243,2249 ----
    tree def, def_stmt;
    enum vect_def_type dt;
  
!   if (vect_print_dump_info (REPORT_DETAILS))
      fprintf (vect_dump, "=== vect_mark_stmts_to_be_vectorized ===");
  
    worklist = VEC_alloc (tree, heap, 64);
*************** vect_mark_stmts_to_be_vectorized (loop_v
*** 2286,2292 ****
    bb = loop->header;
    for (phi = phi_nodes (bb); phi; phi = PHI_CHAIN (phi))
      {
!       if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
          {
            fprintf (vect_dump, "init: phi relevant? ");
            print_generic_expr (vect_dump, phi, TDF_SLIM);
--- 2253,2259 ----
    bb = loop->header;
    for (phi = phi_nodes (bb); phi; phi = PHI_CHAIN (phi))
      {
!       if (vect_print_dump_info (REPORT_DETAILS))
          {
            fprintf (vect_dump, "init: phi relevant? ");
            print_generic_expr (vect_dump, phi, TDF_SLIM);
*************** vect_mark_stmts_to_be_vectorized (loop_v
*** 2303,2309 ****
  	{
  	  stmt = bsi_stmt (si);
  
! 	  if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	    {
  	      fprintf (vect_dump, "init: stmt relevant? ");
  	      print_generic_expr (vect_dump, stmt, TDF_SLIM);
--- 2270,2276 ----
  	{
  	  stmt = bsi_stmt (si);
  
! 	  if (vect_print_dump_info (REPORT_DETAILS))
  	    {
  	      fprintf (vect_dump, "init: stmt relevant? ");
  	      print_generic_expr (vect_dump, stmt, TDF_SLIM);
*************** vect_mark_stmts_to_be_vectorized (loop_v
*** 2321,2327 ****
      {
        stmt = VEC_pop (tree, worklist);
  
!       if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	{
            fprintf (vect_dump, "worklist: examine stmt: ");
            print_generic_expr (vect_dump, stmt, TDF_SLIM);
--- 2288,2294 ----
      {
        stmt = VEC_pop (tree, worklist);
  
!       if (vect_print_dump_info (REPORT_DETAILS))
  	{
            fprintf (vect_dump, "worklist: examine stmt: ");
            print_generic_expr (vect_dump, stmt, TDF_SLIM);
*************** vect_mark_stmts_to_be_vectorized (loop_v
*** 2393,2400 ****
  
  	  if (!vect_is_simple_use (use, loop_vinfo, &def_stmt, &def, &dt))
              {
!               if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS,
! 			    		LOOP_LOC (loop_vinfo)))
                  fprintf (vect_dump, "not vectorized: unsupported use in stmt.");
  	      VEC_free (tree, heap, worklist);
                return false;
--- 2360,2366 ----
  
  	  if (!vect_is_simple_use (use, loop_vinfo, &def_stmt, &def, &dt))
              {
!               if (vect_print_dump_info (REPORT_UNVECTORIZED_LOOPS))
                  fprintf (vect_dump, "not vectorized: unsupported use in stmt.");
  	      VEC_free (tree, heap, worklist);
                return false;
*************** vect_mark_stmts_to_be_vectorized (loop_v
*** 2403,2409 ****
  	  if (!def_stmt || IS_EMPTY_STMT (def_stmt))
  	    continue;
  
!           if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
              {
                fprintf (vect_dump, "worklist: examine use %d: ", i);
                print_generic_expr (vect_dump, use, TDF_SLIM);
--- 2369,2375 ----
  	  if (!def_stmt || IS_EMPTY_STMT (def_stmt))
  	    continue;
  
!           if (vect_print_dump_info (REPORT_DETAILS))
              {
                fprintf (vect_dump, "worklist: examine use %d: ", i);
                print_generic_expr (vect_dump, use, TDF_SLIM);
*************** vect_can_advance_ivs_p (loop_vec_info lo
*** 2446,2452 ****
  
    /* Analyze phi functions of the loop header.  */
  
!   if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
      fprintf (vect_dump, "=== vect_can_advance_ivs_p ===");
  
    for (phi = phi_nodes (bb); phi; phi = PHI_CHAIN (phi))
--- 2412,2418 ----
  
    /* Analyze phi functions of the loop header.  */
  
!   if (vect_print_dump_info (REPORT_DETAILS))
      fprintf (vect_dump, "=== vect_can_advance_ivs_p ===");
  
    for (phi = phi_nodes (bb); phi; phi = PHI_CHAIN (phi))
*************** vect_can_advance_ivs_p (loop_vec_info lo
*** 2454,2460 ****
        tree access_fn = NULL;
        tree evolution_part;
  
!       if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	{
            fprintf (vect_dump, "Analyze phi: ");
            print_generic_expr (vect_dump, phi, TDF_SLIM);
--- 2420,2426 ----
        tree access_fn = NULL;
        tree evolution_part;
  
!       if (vect_print_dump_info (REPORT_DETAILS))
  	{
            fprintf (vect_dump, "Analyze phi: ");
            print_generic_expr (vect_dump, phi, TDF_SLIM);
*************** vect_can_advance_ivs_p (loop_vec_info lo
*** 2465,2471 ****
  
        if (!is_gimple_reg (SSA_NAME_VAR (PHI_RESULT (phi))))
  	{
! 	  if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	    fprintf (vect_dump, "virtual phi. skip.");
  	  continue;
  	}
--- 2431,2437 ----
  
        if (!is_gimple_reg (SSA_NAME_VAR (PHI_RESULT (phi))))
  	{
! 	  if (vect_print_dump_info (REPORT_DETAILS))
  	    fprintf (vect_dump, "virtual phi. skip.");
  	  continue;
  	}
*************** vect_can_advance_ivs_p (loop_vec_info lo
*** 2474,2480 ****
  
        if (STMT_VINFO_DEF_TYPE (vinfo_for_stmt (phi)) == vect_reduction_def)
          {
!           if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
              fprintf (vect_dump, "reduc phi. skip.");
            continue;
          }
--- 2440,2446 ----
  
        if (STMT_VINFO_DEF_TYPE (vinfo_for_stmt (phi)) == vect_reduction_def)
          {
!           if (vect_print_dump_info (REPORT_DETAILS))
              fprintf (vect_dump, "reduc phi. skip.");
            continue;
          }
*************** vect_can_advance_ivs_p (loop_vec_info lo
*** 2486,2497 ****
  
        if (!access_fn)
  	{
! 	  if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	    fprintf (vect_dump, "No Access function.");
  	  return false;
  	}
  
!       if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
          {
  	  fprintf (vect_dump, "Access function of PHI: ");
  	  print_generic_expr (vect_dump, access_fn, TDF_SLIM);
--- 2452,2463 ----
  
        if (!access_fn)
  	{
! 	  if (vect_print_dump_info (REPORT_DETAILS))
  	    fprintf (vect_dump, "No Access function.");
  	  return false;
  	}
  
!       if (vect_print_dump_info (REPORT_DETAILS))
          {
  	  fprintf (vect_dump, "Access function of PHI: ");
  	  print_generic_expr (vect_dump, access_fn, TDF_SLIM);
*************** vect_can_advance_ivs_p (loop_vec_info lo
*** 2501,2507 ****
        
        if (evolution_part == NULL_TREE)
          {
! 	  if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	    fprintf (vect_dump, "No evolution.");
  	  return false;
          }
--- 2467,2473 ----
        
        if (evolution_part == NULL_TREE)
          {
! 	  if (vect_print_dump_info (REPORT_DETAILS))
  	    fprintf (vect_dump, "No evolution.");
  	  return false;
          }
*************** vect_get_loop_niters (struct loop *loop,
*** 2529,2535 ****
  {
    tree niters;
  
!   if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
      fprintf (vect_dump, "=== get_loop_niters ===");
  
    niters = number_of_iterations_in_loop (loop);
--- 2495,2501 ----
  {
    tree niters;
  
!   if (vect_print_dump_info (REPORT_DETAILS))
      fprintf (vect_dump, "=== get_loop_niters ===");
  
    niters = number_of_iterations_in_loop (loop);
*************** vect_get_loop_niters (struct loop *loop,
*** 2539,2545 ****
      {
        *number_of_iterations = niters;
  
!       if (vect_print_dump_info (REPORT_DETAILS, UNKNOWN_LOC))
  	{
  	  fprintf (vect_dump, "==> get_loop_niters:" );
  	  print_generic_expr (vect_dump, *number_of_iterations, TDF_SLIM);
--- 2505,2511 ----
      {
        *number_of_iterations = niters;
  
!       if (vect_print_dump_info (REPORT_DETAILS))
  	{
  	  fprintf (vect_dump, "==> get_loop_niters:" );
  	  print_generic_expr (vect_dump, *number_of_iterations, TDF_SLIM);
*************** vect_analyze_loop_form (struct loop *loo
*** 2566,2581 ****
    loop_vec_info loop_vinfo;
    tree loop_cond;
    tree number_of_iterations = NULL;
-   LOC loop_loc;
  
!   loop_loc = find_loop_location (loop);
! 
!   if (vect_print_dump_info (REPORT_DETAILS, loop_loc))
      fprintf (vect_dump, "=== vect_analyze_loop_form ===");
  
    if (loop->inner)
      {
!       if (vect_print_dump_info (REPORT_OUTER_LOOPS, loop_loc))
          fprintf (vect_dump, "not vectorized: nested loop.");
        return NULL;
      }
--- 2532,2544 ----
    loop_vec_info loop_vinfo;
    tree loop_cond;
    tree number_of_iterations = NULL;
  
!   if (vect_print_dump_info (REPORT_DETAILS))
      fprintf (vect_dump, "=== vect_analyze_loop_form ===");
  
    if (loop->inner)
      {
!       if (vect_print_dump_info (REPORT_OUTER_LOOPS))
          fprintf (vect_dump, "not vectorized: nested loop.");
        return NULL;
      }
*************** vect_analyze_loop_form (struct loop *loo
*** 2584,2590 ****
        || loop->num_nodes != 2
        || EDGE_COUNT (loop->header->preds) != 2)
      {
!       if (vect_print_dump_info (REPORT_BAD_FORM_LOOPS, loop_loc))
          {
            if (!loop->single_exit)
              fprintf (vect_dump, "not vectorized: multiple exits.");
--- 2547,2553 ----
        || loop->num_nodes != 2
        || EDGE_COUNT (loop->header->preds) != 2)
      {
!       if (vect_print_dump_info (REPORT_BAD_FORM_LOOPS))
          {
            if (!loop->single_exit)
              fprintf (vect_dump, "not vectorized: multiple exits.");
*************** vect_analyze_loop_form (struct loop *loo
*** 2603,2609 ****
       executable statements, and the latch is empty.  */
    if (!empty_block_p (loop->latch))
      {
!       if (vect_print_dump_info (REPORT_BAD_FORM_LOOPS, loop_loc))
          fprintf (vect_dump, "not vectorized: unexpected loop form.");
        return NULL;
      }
--- 2566,2572 ----
       executable statements, and the latch is empty.  */
    if (!empty_block_p (loop->latch))
      {
!       if (vect_print_dump_info (REPORT_BAD_FORM_LOOPS))
          fprintf (vect_dump, "not vectorized: unexpected loop form.");
        return NULL;
      }
*************** vect_analyze_loop_form (struct loop *loo
*** 2615,2626 ****
        if (!(e->flags & EDGE_ABNORMAL))
  	{
  	  split_loop_exit_edge (e);
! 	  if (vect_print_dump_info (REPORT_DETAILS, loop_loc))
  	    fprintf (vect_dump, "split exit edge.");
  	}
        else
  	{
! 	  if (vect_print_dump_info (REPORT_BAD_FORM_LOOPS, loop_loc))
  	    fprintf (vect_dump, "not vectorized: abnormal loop exit edge.");
  	  return NULL;
  	}
--- 2578,2589 ----
        if (!(e->flags & EDGE_ABNORMAL))
  	{
  	  split_loop_exit_edge (e);
! 	  if (vect_print_dump_info (REPORT_DETAILS))
  	    fprintf (vect_dump, "split exit edge.");
  	}
        else
  	{
! 	  if (vect_print_dump_info (REPORT_BAD_FORM_LOOPS))
  	    fprintf (vect_dump, "not vectorized: abnormal loop exit edge.");
  	  return NULL;
  	}
*************** vect_analyze_loop_form (struct loop *loo
*** 2628,2634 ****
  
    if (empty_block_p (loop->header))
      {
!       if (vect_print_dump_info (REPORT_BAD_FORM_LOOPS, loop_loc))
          fprintf (vect_dump, "not vectorized: empty loop.");
        return NULL;
      }
--- 2591,2597 ----
  
    if (empty_block_p (loop->header))
      {
!       if (vect_print_dump_info (REPORT_BAD_FORM_LOOPS))
          fprintf (vect_dump, "not vectorized: empty loop.");
        return NULL;
      }
